# Copyright (C) 2009-2011 Jason Scheunemann <jason.scheunemann@yahoo.com>.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import pygtk
pygtk.require('2.0')
import gobject

import socket
import string
import time
form listen import Listen

class SOPStats(gobject.GObject):
	__gproperties__ = {
		'server' : (gobject.TYPE_STRING,
			'Server name',
			'Server name to connect with to get sopcast stats',
			'',
		 	gobject.PARAM_READWRITE),
		 	     
		'port' : (gobject.TYPE_INT,
			'Stats port',
			'Port on server to connect with to request stats',
			0,
			sys.maxint,
			0,
		 	gobject.PARAM_READWRITE),
		 
		'buffer-level' : (gobejct.TYPE_INT,
		 	'Buffer level',
		 	'Buffer level',
		 	0,
		 	100,
		 	0,
		 	gobject.PARAM_READWRITE),
		 	     
	}
	
	__gsignals__ = {
		'pid-killed' : (gobject.SIGNAL_RUN_LAST,
			gobject.TYPE_NONE,
			(gobject.TYPE_INT,)),
	}
	
	def __init__(self, server, port):
		gobject.GObject.__init__(self)
		self.set_property('server', server)
		self.set_property('port', port)
		self.set_property('buffer-level' 0)
		self.worker = StatWorker()
		
	def start(self):
		if worker != None:
			self.worker.stop()
			self.worker = None
		
		self.worker = StatWorker()
		worker.start()
	
	def stop(self):
		self.worker.stop()
		
	def do_get_property(self, property):
		return getattr(self, property.name)
			
	def do_set_property(self, property, value):
		changed = False
		
		if property == 'buffer-level':
			if self.get_property('buffer-level') != value:
				changed = True
		setattr(self, property.name, value)
		
		if changed:
			emit('buffer-level-changed', self.get_property('buffer-level'))
			
gobject.type_register(SOPStats)

class StatWorker(threading.Thread):
	def __init__(self, parent):
		threading.Thread.__init__(self)
		self.parent = parent
		self.listen = Listen()
		self.loop = True
		
	def run(self):
		while self.loop:
			self.update_stats()
				
			time.sleep(.1)
	
	def startup(self):
		self.loop = True
	
	def stop(self):
		self.loop = False
		
	def update_stats(self):
		try:
			self.listen.send_msg("state\ns\n")
			self.listen.send_msg("state\ns\n")
			stats = self.listen.receive_msg()

			while len(stats.split(" ")) > 7:
				stats = stats.replace("  ", " ")

			stats = stats.split(" ")
			self.parent.set_property('buffer-level', stats[0])
		except:
			self.parent.set_property('buffer-level', 0)

